﻿using System;
using System.IO;
using System.Linq;
using System.Text;
using HamerSoft.Wizard.Core.Options;
using UnityEditor;
using UnityEngine;

namespace HamerSoft.Wizard.Core.Sections
{
    public class Setup : Section
    {
        public override string Name => "Setup";

        public Setup() : base()
        {
        }

        public Setup(string appName, string version, string publisher)
        {
            Options.Add("AppId", new StringOption("AppId", "{{" + Guid.NewGuid() + "}"));
            Options.Add("AppName", new DefinedOption("AppName", appName));
            Options.Add("AppExeName", new DefineOption("AppExeName", appName, "{0}.exe"));
            Options.Add("ProductName", new DefineOption("ProductName", Application.productName));
            Options.Add("AppVersion", new DefinedOption("AppVersion", version));
            Options.Add("AppPublisher", new DefinedOption("AppPublisher", publisher));
            Options.Add("AppPublisherUrl", new DefinedOption("AppPublisherUrl", $"https://{publisher}.com"));
            Options.Add("DefaultDirName", new StringOption("DefaultDirName", "{commonpf}\\{#MyAppName}"));
            Options.Add("PrivilegesRequiredOverridesAllowed", new StringOption("PrivilegesRequiredOverridesAllowed", "dialog"));
            Options.Add("OutputBaseFilename", new StringOption("OutputBaseFilename", "Setup"));
            Options.Add("Compression", new StringOption("Compression", "lzma"));
            Options.Add("SolidCompression", new BooleanOption("SolidCompression", false));
            Options.Add("WizardStyle", new StringOption("WizardStyle", "modern"));
            Options.Add("Uninstallable", new BooleanOption("Uninstallable", true));
            var wizardImageLarge = Resources.Load("WizardSetupImages/WizardImageFile");
            var file = AssetDatabase.GetAssetPath(wizardImageLarge);
            Options.Add("SetupIconFile", new FileOption("SetupIconFile", Path.Combine(Path.GetDirectoryName(file), "WizardIcon.ico"), ".ico", true));
            Options.Add("WizardImageFile", new FileOption("WizardImageFile", Path.Combine(Path.GetDirectoryName(file), "WizardImageFile.bmp"), ".bmp", true));
            Options.Add("WizardSmallImageFile", new FileOption("WizardSmallImageFile", Path.Combine(Path.GetDirectoryName(file), "WizardSmallImageFile.bmp"), ".bmp", true));
        }

        public void UpdateOption<TValue>(string key, TValue value)
        {
            if (!Options.ContainsKey(key))
                Options.Add(key, new DefinedOption(key, (string)(object)value));
            else if (Options[key] is InstallerOption<TValue> io)
                io.UpdateValue(value);
        }

        public bool SetBuildDir(string path)
        {
            if (!TryGetProductName(path, out var productName))
                return false;

            SetDefineOption("BuildDir", path);
            SetDefineOption("ProductName", productName);
            return true;
        }

        private bool TryGetProductName(string buildPath, out string productName)
        {
            var directoryInfo = new DirectoryInfo(buildPath);
            var exes = directoryInfo.GetFiles().Where(f => f.Extension == ".exe");
            var dataFolder = directoryInfo.GetDirectories().FirstOrDefault(d => d.Name.EndsWith("_Data"));
            var application = exes.FirstOrDefault(e => dataFolder?.Name.Contains(e.Name.Replace(e.Extension, "")) ?? false);
            var hasUnityDll = directoryInfo.GetFiles().ToList().Exists(f => f.Name.Equals("UnityPlayer.dll", StringComparison.OrdinalIgnoreCase));
            bool success = application != null && hasUnityDll;
            productName = success ? application.Name.Replace(application.Extension, "") : null;
            return success;
        }

        protected void SetDefineOption(string key, string value)
        {
            if (!Options.ContainsKey(key))
                Options.Add(key, new DefineOption(key, value));
            else if (Options[key] is InstallerOption<string> io)
                io.UpdateValue(value);
        }

        public override string Transpile()
        {
            StringBuilder builder = new StringBuilder();
            builder.AppendLine("; This Inno Setup Script is generated by Wizard! The Inno Setup plugin for Unity3D!");
            builder.AppendLine("; For detailed information and documentation about Wizard see: https://gitlab.com/ruben.hamers/UnityNstaller");
            builder.AppendLine();

            foreach (DefinableOption option in Options.Values.Where(v => v is DefinableOption).Cast<DefinableOption>())
                builder.AppendLine(option.Define());

            builder.AppendLine(String.Empty);

            builder.AppendLine($"[{Name}]");
            builder.AppendLine("; NOTE: The value of AppId uniquely identifies this application. Do not use the same AppId value in installers for other applications.");
            builder.AppendLine("; Use Wizard to generate a new GUID if you need a new key, You can always use InnoSetup directly: (To generate a new GUID, click Tools | Generate GUID inside the InnoSetup IDE.)");
            builder.AppendLine();
            foreach (var transpilable in Options)
                builder.AppendLine(transpilable.Value.Transpile());

            return builder.ToString();
        }
    }
}